This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes
Bug 1029348 - Review Request: objectweb-asm3 - Java bytecode manipulation and analysis framework
Review Request: objectweb-asm3 - Java bytecode manipulation and analysis fram...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michal Srb
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-12 03:46 EST by Mikolaj Izdebski
Modified: 2014-08-29 11:53 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-13 07:29:15 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
msrb: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Mikolaj Izdebski 2013-11-12 03:46:19 EST
Spec URL: http://mizdebsk.fedorapeople.org/review/objectweb-asm3/objectweb-asm3.spec
SRPM URL: http://mizdebsk.fedorapeople.org/review/objectweb-asm3/objectweb-asm3-3.3.1-1.fc21.src.rpm
Description: ASM is an all purpose Java bytecode manipulation and analysis framework.  It can be used to modify existing classes or dynamically generate classes, directly in binary form.  Provided common transformations and analysis algorithms allow to easily assemble custom complex transformations and code analysis tools.
Fedora Account System Username: mizdebsk
Comment 1 Michal Srb 2013-11-12 04:48:40 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable




===== MUST items =====

Generic:
[!]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "BSD (3 clause)", "Apache (v2.0)", "Unknown or generated". 2 files have
     unknown license. Detailed output of licensecheck in
     /home/msrb/review/1029348-objectweb-asm3/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[!]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: objectweb-asm3-3.3.1-1.fc21.noarch.rpm
          objectweb-asm3-javadoc-3.3.1-1.fc21.noarch.rpm
          objectweb-asm3-3.3.1-1.fc21.src.rpm
objectweb-asm3.noarch: W: spelling-error Summary(en_US) bytecode -> byte code, byte-code, decorate
objectweb-asm3.noarch: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
objectweb-asm3.noarch: W: class-path-in-manifest /usr/share/java/objectweb-asm3/asm-xml.jar
objectweb-asm3.src: W: spelling-error Summary(en_US) bytecode -> byte code, byte-code, decorate
objectweb-asm3.src: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
objectweb-asm3.src: E: specfile-error mvn_install: invalid option -- 'J'
objectweb-asm3.src: E: specfile-error error: Unknown option J in mvn_install()
3 packages and 0 specfiles checked; 2 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint objectweb-asm3 objectweb-asm3-javadoc
objectweb-asm3.noarch: W: spelling-error Summary(en_US) bytecode -> byte code, byte-code, decorate
objectweb-asm3.noarch: W: spelling-error %description -l en_US bytecode -> byte code, byte-code, decorate
objectweb-asm3.noarch: W: class-path-in-manifest /usr/share/java/objectweb-asm3/asm-xml.jar
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
objectweb-asm3 (rpmlib, GLIBC filtered):
    jpackage-utils

objectweb-asm3-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
objectweb-asm3:
    mvn(asm:asm)
    mvn(asm:asm-all)
    mvn(asm:asm-analysis)
    mvn(asm:asm-commons)
    mvn(asm:asm-tree)
    mvn(asm:asm-util)
    mvn(asm:asm-xml)
    mvn(org.eclipse.jetty.orbit:org.objectweb.asm)
    objectweb-asm3
    osgi(org.objectweb.asm.all)

objectweb-asm3-javadoc:
    objectweb-asm3-javadoc



Source checksums
----------------
http://download.forge.ow2.org/asm/asm-3.3.1.tar.gz :
  CHECKSUM(SHA256) this package     : 69a523d41c82d7979c9b47271e31187e23c064e1d2a93b52950463bcb80197f5
  CHECKSUM(SHA256) upstream package : 69a523d41c82d7979c9b47271e31187e23c064e1d2a93b52950463bcb80197f5


Jar and class files in source
-----------------------------
./asm-3.3.1/examples/jasmin/test/jasmin.jar


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1029348
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java

Issues:
=======
- Bundled jar/class files should be removed before build
  Note: Jar files in source (see attachment)
  See: http://fedoraproject.org/wiki/Packaging:Java#Pre-
  built_JAR_files_.2F_Other_bundled_software'

Bundled JAR is only needed by tests, so it can be safely removed. Also, it seems like the JAR itself bundles MIT licensed lava_cup.

- some tests are licensed under ASL 1.1 and ASL 2.0. License tag in spec file is correct, but ASL 2.0 license text should be part of the SRPM.
Comment 2 Mikolaj Izdebski 2013-11-12 04:55:25 EST
- Added ASL 2.0 license to SRPM
- removed bundled JAR before building

Spec URL: http://mizdebsk.fedorapeople.org/review/objectweb-asm3/objectweb-asm3.spec
SRPM URL: http://mizdebsk.fedorapeople.org/review/objectweb-asm3/objectweb-asm3-3.3.1-1.fc21.src.rpm
Comment 3 Michal Srb 2013-11-12 04:56:28 EST
The package looks good now.

Approved.
Comment 4 Mikolaj Izdebski 2013-11-12 05:00:25 EST
New Package SCM Request
=======================
Package Name: objectweb-asm3
Short Description: Java bytecode manipulation and analysis framework
Owners: mizdebsk msrb sochotni dwalluck fnasser overholt
Branches: f20
InitialCC: java-sig goldmann caniszczyk richardfearn
Comment 5 Gwyn Ciesla 2013-11-12 08:18:26 EST
Git done (by process-git-requests).
Comment 6 Darryl L. Pierce 2014-08-29 09:10:16 EDT
Package Change Request
======================
Package Name: objectweb-asm3
New Branches: epel7
Owners: mcpierce
InitialCC: java-sig
Comment 7 Gwyn Ciesla 2014-08-29 11:53:00 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.